// ---------- Attention: Generated code, please do not modify! -----------

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import jakarta.faces.component.behavior.ClientBehaviorHolder;
import jakarta.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUITreeListbox;
import org.apache.myfaces.tobago.model.Selectable;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import jakarta.annotation.Generated;
import jakarta.el.ELException;
import jakarta.faces.FacesException;
import jakarta.faces.application.ProjectStage;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import jakarta.el.MethodExpression;
import jakarta.el.ValueExpression;

/**
 A tree data structure displayed as a set of list boxes.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.TreeListboxTagDeclaration}.
 */
@Generated("component.stg")
public class UITreeListbox
    extends AbstractUITreeListbox implements ClientBehaviorHolder {

  private static final Tags TAG = Tags.treeListbox;

  public static final String COMPONENT_TYPE = TAG.componentType();

  public static final String COMPONENT_FAMILY = "jakarta.faces.Data";


  enum PropertyKeys {
    markup,
    size,
    selectable,
    customClass,
    required,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  The number of the shown rows in the element. E.g. the size attribute of the select element in HTML.

  */
  public java.lang.Integer getSize() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.size);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setSize(java.lang.Integer size) {
    getStateHelper().put(PropertyKeys.size, size);
  }

  /**
  Flag indicating whether or not this component should be render selectable items.
   Possible values are:
   <ul>
   <li><strong>single</strong> : a single section tree is rendered</li>
   <li><strong>multiLeafOnly</strong> : a multi section tree is rendered,
   only Leaf's are selectable</li>
   <li><strong>singleLeafOnly</strong> : a single section tree is rendered,
   only Leaf's are selectable</li>
   </ul>
  <br>Default: <code>single</code><br>Allowed Values: <code>single,multiLeafOnly,singleLeafOnly</code>
  */
  public org.apache.myfaces.tobago.model.Selectable getSelectable() {
    org.apache.myfaces.tobago.model.Selectable selectable = (org.apache.myfaces.tobago.model.Selectable) getStateHelper().eval(PropertyKeys.selectable);
    if (selectable != null) {
      return selectable;
    }
    return org.apache.myfaces.tobago.model.Selectable.single;
  }

  public void setSelectable(org.apache.myfaces.tobago.model.Selectable selectable) {
    getStateHelper().put(PropertyKeys.selectable, selectable);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  Flag indicating that a value is required.
   If the value is an empty string a
   ValidationError occurs and a Error Message is rendered.
  <br>Default: <code>false</code>
  */
  public boolean isRequired() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.required);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setRequired(boolean required) {
    getStateHelper().put(PropertyKeys.required, required);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}